searchNodes=[{"type":"module","title":"Tim","doc":"Tim the tiny timer. Sometimes you want a simple tool to estimate execution time. Tim can help! Explanation and usage Tim provides the macro time that takes any valid Elixir expression and returns a map containing several statistics for the expression's execution time, the result of the evaluated expression, and the expression's string representation. To use time , require or import Tim into your environment and pipe in the expression: iex&gt; require Tim iex&gt; 1 .. 10 ... &gt; |&gt; Enum . map ( &amp; &amp;1 * 2 / ( ( 1 + 10 ) * 10 ) ) ... &gt; |&gt; Enum . sum ( ) ...&gt; |&gt; Tim . time ( ) %{ expr : &quot;1..10 |&gt; Enum.map(&amp;(&amp;1 * 2 / ((1 + 10) * 10))) |&gt; Enum.sum()&quot; , max : 46 , mean : 46.0 , median : 46 , min : 46 , n : 1 , result : 1.0 , unit : :microsecond } Actual timing statistics will vary. By default, all times are in microseconds. The time macro has two optional keyword arguments: :n - number of times the expression is executed to gather timing statistics (defaults to 1) :unit - unit of time in the reported statistics, which can be one of :microsecond (default), :millisecond , :second , :minute , or :hour Tim also provides an inspect macro that applies IO.inspect to the timing data returned by Tim.time , but then returns the result of the expression being timed. This allows timing data to be captured in the middle of a pipeline. Like Tim.time , inspect also takes the optional keyword arguments :n and :unit . Here's an example of using inspect : iex&gt; require Tim iex&gt; :timer . sleep ( 1_000 ) |&gt; Tim . inspect ( n : 2 , unit : :second ) Timing data : %{ max : 1.000952 , min : 1.00057 , unit : :second , expr : &quot;:timer.sleep(1000)&quot; , n : 2 , mean : 1.000761 , median : 1.000952 } :ok Under the hood The body of the Tim.time macro wraps around Erlang's :timer.tc function that returns {&lt;execution time in microseconds&gt;, &lt;result value&gt;} . The reason that time is a macro is so that the entire expression remains unevaluated until called inside :timer.tc . To generate timing statistics over independent executions, :timer.tc and the expression are evaluated n times.","ref":"Tim.html"},{"type":"macro","title":"Tim.inspect/2","doc":"Takes an Elixir expression and returns the evaluated result while also applying IO.inspect to the map of timing stats. inspect has the following optional keyword arguments: :n - number of times the expression is evaluated to build statistics; defaults to 1 :unit - unit of time for the timing statistics; :microsecond (default) | :millisecond | :second | :minute | :hour","ref":"Tim.html#inspect/2"},{"type":"macro","title":"Tim.time/2","doc":"Takes an Elixir expression and returns a map of timing stats and the evaluated result. time has the following optional keyword arguments: :n - number of times the expression is evaluated to build statistics; defaults to 1 :unit - unit of time for the timing statistics; :microsecond (default) | :millisecond | :second | :minute | :hour","ref":"Tim.html#time/2"},{"type":"type","title":"Tim.unit/0","doc":"","ref":"Tim.html#t:unit/0"},{"type":"module","title":"Tim.Stats","doc":"Aggregates stats.","ref":"Tim.Stats.html"},{"type":"function","title":"Tim.Stats.collect/2","doc":"Return a map of statistical aggregates for a list of numbers.","ref":"Tim.Stats.html#collect/2"},{"type":"function","title":"Tim.Stats.max/1","doc":"Compute the maximum value of a list of numbers. This aliases Enum.max .","ref":"Tim.Stats.html#max/1"},{"type":"function","title":"Tim.Stats.mean/1","doc":"Compute the mean value of a list of numbers. Exmaples iex&gt; Tim.Stats . mean ( [ 1 ] ) 1.0 iex&gt; Tim.Stats . mean ( [ 1 , 2 , 3 , 4 ] ) 2.5","ref":"Tim.Stats.html#mean/1"},{"type":"function","title":"Tim.Stats.median/1","doc":"Compute the median value of a list of numbers. This function always returns an element of the list. Exmaples iex&gt; Tim.Stats . median ( [ 1 ] ) 1 iex&gt; Tim.Stats . median ( [ 1 , 2 , 3 ] ) 2 iex&gt; Tim.Stats . median ( [ 1 , 2 , 3 , 4 ] ) 3","ref":"Tim.Stats.html#median/1"},{"type":"function","title":"Tim.Stats.min/1","doc":"Compute the minimum value of a list of numbers. This aliases Enum.min .","ref":"Tim.Stats.html#min/1"},{"type":"extras","title":"README","doc":"[![Version][hex-pm-version-badge]][hex-pm-versions] Tim the tiny timer. Sometimes you want a simple tool to estimate execution time. Tim can help!","ref":"readme.html"},{"type":"extras","title":"README - Explanation and usage","doc":"Tim provides the macro time that takes any valid Elixir expression and returns a map containing several statistics for the expression's execution time, the result of the evaluated expression, and the expression's string representation. To use time , require or import Tim into your environment and pipe in the expression: iex&gt; require Tim iex&gt; 1 .. 10 ... &gt; |&gt; Enum . map ( &amp; &amp;1 * 2 / ( ( 1 + 10 ) * 10 ) ) ... &gt; |&gt; Enum . sum ( ) ...&gt; |&gt; Tim . time ( ) %{ expr : &quot;1..10 |&gt; Enum.map(&amp;(&amp;1 * 2 / ((1 + 10) * 10))) |&gt; Enum.sum()&quot; , max : 46 , mean : 46.0 , median : 46 , min : 46 , n : 1 , result : 1.0 , unit : :microsecond } Actual timing statistics will vary. By default, all times are in microseconds. The time macro has two optional keyword arguments: :n - number of times the expression is executed to gather timing statistics (defaults to 1) :unit - unit of time in the reported statistics, which can be one of :microsecond (default), :millisecond , :second , :minute , or :hour Tim also provides an inspect macro that applies IO.inspect to the timing data returned by Tim.time , but then returns the result of the expression being timed. This allows timing data to be captured in the middle of a pipeline. Like Tim.time , inspect also takes the optional keyword arguments :n and :unit . Here's an example of using inspect : iex&gt; require Tim iex&gt; :timer . sleep ( 1_000 ) |&gt; Tim . inspect ( n : 2 , unit : :second ) Timing data : %{ max : 1.000952 , min : 1.00057 , unit : :second , expr : &quot;:timer.sleep(1000)&quot; , n : 2 , mean : 1.000761 , median : 1.000952 } :ok","ref":"readme.html#explanation-and-usage"},{"type":"extras","title":"README - Under the hood","doc":"The body of the Tim.time macro wraps around Erlang's :timer.tc function that returns {&lt;execution time in microseconds&gt;, &lt;result value&gt;} . The reason that time is a macro is so that the entire expression remains unevaluated until called inside :timer.tc . To generate timing statistics over independent executions, :timer.tc and the expression are evaluated n times.","ref":"readme.html#under-the-hood"}]